package de.ids_mannheim.korap.openthesaurus;

import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;
import java.util.concurrent.atomic.AtomicLong;

@RestController
public class ResponseController {

    private final AtomicLong counter = new AtomicLong();

    @GetMapping("/openthesaurus")
    public Response openthesaurus(@RequestParam(value = "word", defaultValue = "") String word) {

        List<List<String>> synsetList = DoOnStartup.thesaurusDict.get(word);
        if (synsetList == null) {return new Response(counter.incrementAndGet(), new String[0][]);}
        String[][] synsetArrayAll = new String[synsetList.size()][];
        for (int i=0; i < synsetList.size(); i++) {
            List<String> synset = synsetList.get(i);
            String[] synsetArray = synset.toArray(new String[synset.size()]);
            synsetArrayAll[i] = synsetArray;
        }

        return new Response(counter.incrementAndGet(), synsetArrayAll);
    }
}
